clear;
close all;

randn('state',sum(100*clock));
rand('state',sum(100*clock));

hemo=1;
gamma=0;

if 1  %one vs repeated trials
    STORAGE=1;
    NOISE=1; %use spatially correlated noise; if=0, use ODE45
    n_trials=100;%60 %trials per set size per "subject"
    no_changeTR=n_trials/2;
    total_runs=20;%10
    meshplot=0;
    lineplot=0;
    decision_node_plot=0;
    STORE1=1; %flag used to tag the first time an output file is created
    SimName='Metrics';
    Standard=1;
    TnM=0;
else
    STORAGE=0;
    NOISE=1; 		%use spatially correlated noise
    n_trials=1;
    total_runs=1;
    nSS=1
    meshplot=0;
    lineplot=1;
    decision_node_plot=1;
end

storeFields=1;

if TnM
    behData=[.977; .942; .9; .862; .733; .685];
elseif Standard
    behData= [99.21	97.89;
        97.89	97.89;
        94.47	93.95;
        93.16	90.53;
        92.21	81.32;
        89.21	73.95];
else
    behData = [0.87	0.80;
        0.82	0.61;
        0.76	0.46];
    
    behDataOrig = [.89 .84;
        .81 .64;
        .75 .55];
    
end
if (Standard)
    SSt=[1 3 5];
    nSS=numel(SSt);
elseif (TnM)
    SSt=[1 2 3 4 6 8];
    nSS=numel(SSt);
else
    SSt=[2 4 6];
    nSS=numel(SSt);
end
%%%%% Parameter values

n_field=361;           %must be odd;
C=fix(n_field/2)+1;
D2U=1;
U2D=1;
MS2TS=.5;
% TS2MS=2;


if(hemo) && (gamma)
    
    MS2TS=.5;
    lamda=1.3;%2;
    T0=0;
    n=4;
    total_hemo_time=28;
    hemo_ts=0:(.001/MS2TS):total_hemo_time;
    hemo_fn=((hemo_ts-T0).^(n-1)/((lamda^n).*factorial(n-1)).*exp(-(hemo_ts-T0)/lamda));
    
elseif (hemo)
    n1=7; %6; %5;%6;%5;
    t1=.875;%.9;%1.1;
    n2=12.25;%12;
    t2=1; %.95; %.900;%.9;
    a2=.0000000000016;%.4;
    total_hemo_time=28; %20; %20s
    hemo_ts=0:(.001/MS2TS):total_hemo_time;
    c1=max((hemo_ts.^n1).*exp(-hemo_ts/t1));
    c2=max((hemo_ts.^n2).*exp(-hemo_ts/t2));
    hemo_fn=(c1*(hemo_ts.^(n1)).*exp(-hemo_ts/t1))-a2*c2*(hemo_ts.^(n2)).*exp(-hemo_ts/t2);
    hemo_fn=hemo_fn/max(hemo_fn);
    
end



%if running full set
total_iterations=total_runs*nSS*n_trials;
current_iteration=0;

disp('starting simulation');
tic_total=tic;
running_time=0;

% timing parameters: 1 time step = 2ms
init_time=floor(100*MS2TS);
if (TnM)
    sample_time=floor(150*MS2TS);
else
    sample_time=floor(500*MS2TS);
end
delay=floor(1200*MS2TS);
test_time=floor(500*MS2TS);
update_time=floor(300*MS2TS);
n_time =init_time+sample_time+delay+test_time+update_time;
t_init=0.; t_final=n_time-1;


%SimName='Testing';
SimName='Testing';
DataName='DATA_testing';
new_n_time=n_time-1;
sizeZero=10000;
if(hemo)
    total_ts=(new_n_time)*n_trials;
    total_hemo_time=total_ts+sizeZero*n_trials;
    hemo_start = 1;             %trial onset
    pad1=size(hemo_fn,2); %end of first padding
    pad2=(total_hemo_time-hemo_start)+pad1; %start of second padding
    size_hemopad=2*size(hemo_fn,2)+(total_hemo_time-hemo_start);
    size_hemo=(total_hemo_time-hemo_start)+size(hemo_fn,2)+1;
    
    nOut_id=zeros(total_runs,nSS,total_ts);
    nOut_is=zeros(total_runs,nSS,total_ts);
    nOut_ig=zeros(total_runs,nSS,total_ts);
    nOut_u=zeros(total_runs,nSS,total_ts);
    nOut_v=zeros(total_runs,nSS,total_ts);
    nOut_w=zeros(total_runs,nSS,total_ts);
    
    hemopad_id=zeros(1,size_hemopad);
    hemopad_is=zeros(1,size_hemopad);
    hemopad_ig=zeros(1,size_hemopad);
    hemopad_u=zeros(1,size_hemopad);
    hemopad_v=zeros(1,size_hemopad);
    hemopad_w=zeros(1,size_hemopad);
end
gateTrack=zeros(total_runs,nSS,n_trials,n_time);
idTrack=zeros(total_runs,nSS,n_trials,n_time);
isTrack=zeros(total_runs,nSS,n_trials,n_time);
peakStoreW=zeros(total_runs,nSS,n_trials);
peakStoreWend=zeros(total_runs,nSS,n_trials);
peakStoreU=zeros(total_runs,nSS,n_trials);
id_u_track=zeros(total_runs,nSS,n_trials,n_time);
is_w_track=zeros(total_runs,nSS,n_trials,n_time);
fuTrack=zeros(total_runs,nSS,n_trials,n_time);
fwTrack=zeros(total_runs,nSS,n_trials,n_time);
fvTrack=zeros(total_runs,nSS,n_trials,n_time);
% w_field_store=zeros(nSS,n_time,n_field,n_trials);
% u_field_store=zeros(nSS,n_time,n_field,n_trials);

w_iiDTrack=zeros(total_runs,nSS,n_trials,n_time);
u_to_id=zeros(total_runs,nSS,n_trials,n_time);
s_isTrack=zeros(total_runs,nSS,n_trials,n_time);
sNoiseTrack=zeros(total_runs,nSS,n_trials,n_time);

w_iiSTrack=zeros(total_runs,nSS,n_trials,n_time);
w_to_is=zeros(total_runs,nSS,n_trials,n_time);
s_idTrack=zeros(total_runs,nSS,n_trials,n_time);
dNoiseTrack=zeros(total_runs,nSS,n_trials,n_time);


uidTrack=zeros(total_runs,nSS,total_ts);
uisTrack=zeros(total_runs,nSS,total_ts);
uuTrack=zeros(total_runs,nSS,total_ts);
uvTrack=zeros(total_runs,nSS,total_ts);
uvgTrack=zeros(total_runs,nSS,total_ts);
vuTrack=zeros(total_runs,nSS,total_ts);
vwTrack=zeros(total_runs,nSS,total_ts);
wisTrack=zeros(total_runs,nSS,total_ts);
widTrack=zeros(total_runs,nSS,total_ts);
wuTrack=zeros(total_runs,nSS,total_ts);
wwTrack=zeros(total_runs,nSS,total_ts);
wvTrack=zeros(total_runs,nSS,total_ts);
wvgTrack=zeros(total_runs,nSS,total_ts);



% fieldNoiseW=zeros(total_runs,nSS,n_trials,2);
% fieldNoiseU=zeros(total_runs,nSS,n_trials,2);
noiseU=zeros(n_time,n_field);
noiseW=zeros(n_time,n_field);

CDA_time=300;
sum_U_sig=zeros(nSS,n_trials,CDA_time);
sum_V_sig=zeros(nSS,n_trials,CDA_time);
sum_W_sig=zeros(nSS,n_trials,CDA_time);

changeTrack=zeros(total_runs,nSS,n_trials);
resp=zeros(total_runs,nSS,n_trials);


for paramIter=1:17
    for rct=1:total_runs
        if rct==1 & storeFields==1
            %         vFieldStorage=zeros(total_runs,nSS,n_trials,n_time,n_field);
            %         wFieldStorage=zeros(total_runs,nSS,n_trials,n_time,n_field);
            %         uFieldStorage=zeros(total_runs,nSS,n_trials,n_time,n_field);
        end
        SStrack=0;
        allResponse=zeros(nSS,n_trials);
        for SS=SSt%startSS:stopSS
            SS
            SStrack=SStrack+1;
            maxTrialCt=[n_trials/2 n_trials/2];
            trialTypeCt=[0 0];
            
            
            if(hemo)
                timeH=0;
            end
            
            for trial_ct=1:n_trials
                TrialOver=0;
                RT=0;
                if (hemo)
                    timeH = timeH+1;
                end
                %             if trial_ct > no_changeTR
                %                 change=0;
                %             else change=1;
                %             end
                if trialTypeCt(1)==maxTrialCt(1)
                    change = 1;
                    changeTrack(rct,SStrack,trial_ct)=1;
                    trialTypeCt(2)=trialTypeCt(2)+1;
                elseif trialTypeCt(2)==maxTrialCt(2)
                    change=0;
                    changeTrack(rct,SStrack,trial_ct)=0;
                    trialTypeCt(1)=trialTypeCt(1)+1;
                else
                    change=round(rand);
                    changeTrack(rct,SStrack,trial_ct)=change;
                    trialTypeCt(change+1)=trialTypeCt(change+1)+1;
                end
                
                tic_iteration=tic;
                
                if (Standard)
                    stim_values=[-160,-120,-80,-40,0,40,80,120,160];
                    stim_order=perms(stim_values);
                    stim1_pos=stim_order(round(1+rand*362879),:);
                    
                    stim2_pos =stim1_pos;
                    if change ==1
                        stim2_pos(1,1) =stim1_pos(1,9);
                    end
                elseif (TnM)
                    stim_values=[-160,-120,-80,-40,0,40,80,120,160];
                    stim_order=perms(stim_values);
                    stim1_pos=stim_order(round(1+rand*362879),:);
                    
                    stim2_pos =stim1_pos;
                    if change ==1
                        stim2_pos(1,1) =stim1_pos(1,9);
                    end
                else %metric
                    stim_values=[-160 -100 -40 20 80 140];
                    stim_order=randperm(6);
                    stim1_pos=stim_values(stim_order);
                    stim2_pos=stim1_pos;
                    dir=round(rand);
                    if dir==0
                        dir=-1;
                    end
                    if change==1
                        stim2_pos(1)=stim2_pos(1)+(36*dir);%%%%change to 40 was 36
                    end
                    if stim2_pos(1)<-180
                        stim2_pos(1)=stim2_pos(1)+360;
                    end
                    
                    %                 if SS==2
                    %                     stim_values=[-100 80 -70;
                    %                                  -100 80 110];
                    %                     index=ceil(rand*2);
                    %                     stim_order=stim_values(ceil(index),:);
                    %                     stim1_pos =stim_order;
                    %
                    %                     stim2_pos =stim1_pos;
                    %                     if change ==1
                    %                         stim2_pos(1,index) =stim1_pos(1,3);
                    %                     end
                    %                 elseif SS==4
                    %                     stim_values=[-140 -50 40 130 -110;
                    %                         -140 -50 40 130 -20;
                    %                         -140 -50 40 130 70;
                    %                         -140 -50 40 130 160];
                    %                     index=ceil(rand*4);
                    %                     stim_order=stim_values(ceil(index),:);
                    %                     stim1_pos =stim_order;
                    %
                    %                     stim2_pos =stim1_pos;
                    %                     if change ==1
                    %                         stim2_pos(1,index) =stim1_pos(1,5);%9);
                    %                     end
                    %                 elseif SS==6
                    %                     stim_values=[-160 -100 -40 20 80 140 -130;
                    %                                  -160 -100 -40 20 80 140 -70;
                    %                                  -160 -100 -40 20 80 140 -10;
                    %                                  -160 -100 -40 20 80 140 50;
                    %                                  -160 -100 -40 20 80 140 110;
                    %                                  -160 -100 -40 20 80 140 170];
                    %                     index=ceil(rand*6);
                    %                     stim_order=stim_values(ceil(index),:);
                    %                     stim1_pos =stim_order;
                    %
                    %                     stim2_pos =stim1_pos;
                    %                     if change ==1
                    %                         stim2_pos(1,index) =stim1_pos(1,7);%9);
                    %                     end
                    %                 end
                end
                stimposStore(rct,SS,trial_ct,:)=stim1_pos;
                stim_str=30/(1+(sqrt(SS-1)*.08));%.12));%.14));%.22));
                stim_width=3;
                
                % stim1
                n_stim1_on  =init_time;
                n_stim1_off  =n_stim1_on+sample_time;
                ct_stim1=SS;
                
                stim1_strength=[stim_str,stim_str,stim_str,stim_str,stim_str,stim_str,stim_str,stim_str];
                stim1_width  =[stim_width,stim_width,stim_width,stim_width,stim_width,stim_width,stim_width,stim_width];
                
                % stim2
                n_stim2_on =n_stim1_off+delay;
                n_stim2_off =n_stim2_on+test_time;
                ct_stim2=ct_stim1;
                
                stim2_strength=stim1_strength;
                stim2_width  =stim1_width;
                
                % h change parameters: use for mode control
                h_u=-5;%-5.25;%-5.5;%-6.75;
                h_v=-12;
                h_w=-4.5;
                
                %Decision nodes
                %beta_g = 0.5;  %gate node
                tau_g = 80;   %gate node
                h_g = -4.92; %-4.85;     %gate node
                w_igw = .03;      %from w to gate node
                w_gS = .01;       %from stim input to gate node
                transient_time = floor(30*MS2TS);%Was 30   %duration of transient associated with each stim
                w_trans = 18;   %strength of transient input
                w_gg = 4.8; %4.0;     %self-excitation of gate node
                w_ig = 4.75;%4.25;%4.5;     %boost from gate node to decision nodes when gate node "on"
                
                beta_i = 5;
                tau_i = 80;
                if TnM || Standard
                    h_is=-3.8;%-4.8;
                else
                    %                 if SS==6
                    %                     h_is=-5;
                    %                 else
                    %                     h_is = -6+2*sigmoid(SS,1,4);%(1./(1+sqrt(SS-1)));%-6;
                    %                 end
                    h_is=-5;
                end
                h_id = -8;%-5;
                w_iiD=1.85*2;
                w_iiS=1.85*2;
                ci=100;%50;%32;%32;%14*1.5;
                
                w_idu = 2.8;%2.6;%1.8;%2;%1.8/(1+(sqrt(SS-1)*0));
                w_isw = .15*2.75;%.15*2;%.1;
                w_uid = 4;%3.5;%5.7;%5.7;%6.5;%4;%1;
                w_uis = .15;%5;
                w_wid = 1;
                w_wis = 1;
                
                w_isv =.1*2;
                
                
                pAllN=[.65:.1:2.25];
                noise_sigma=1;
                noise_strength=.05*.5;%pAllN(paramIter);%.5;
                noise_strength_nodes=.12;
                noise_strength_gate=.025;
                h_noisestr_u=18;
                h_noisestr_v=15;
                h_noisestr_w=25;
                tau_noise=50;
                
                % Amari dynamics parameters
                tau_u=80.;
                tau_v=10.;
                tau_w=80.;
                beta=5;
                pAll=1.025:.025:1.425;  %%For KERNELS 
                % kernels: width and strength parameters
                uu_sigma=3;%*pAll(paramIter);
                w_uu=1.5;%2.75;%2.75;%2.75;%2.25;%2.0;
                
                uv_sigma=14;%*pAll(paramIter);%22*1.0;
                w_uv=1.35;%2.15;%2.3;%2.15;%1.9;%2.15;
                w_uv_const=.005;%.02;%.01;
                
                vu_sigma=10*pAll(paramIter);
                w_vu=1.7;%2.0;
                
                vw_sigma=5*pAll(paramIter);
                w_vw=1.95;
                
                wv_sigma=35;%*pAll(paramIter);
                w_wv=0.325;%0.325;
                w_wv_const=.06*1;%0.08*1;
                
                wu_sigma=5;
                w_wu=1.6;
                
                ww_sigma=3;%*pAll(paramIter);
                w_ww=3.75;%3.5;%3.3;
                w_wS=.2;
                
                % input kernels
                stim1_input=zeros(1,n_field);
                for ct=1:ct_stim1
                    stim1_input=stim1_input+gauss(n_field-1,(fix(stim1_pos(ct)*D2U)+C)-1,stim1_strength(ct),stim1_width(ct),0);
                end
                
                if (TnM)
                    stim2_input=zeros(1,n_field);
                    stim2_input=stim2_input+gauss(n_field-1,(fix(stim2_pos(1)*D2U)+C)-1,stim2_strength(1),stim2_width(1),0);
                else
                    stim2_input=zeros(1,n_field);
                    for ct=1:ct_stim2
                        stim2_input=stim2_input+gauss(n_field-1,(fix(stim2_pos(ct)*D2U)+C)-1,stim2_strength(ct),stim2_width(ct),0);
                    end
                end
                %%%% Constructing the stimulus
                stimulus=zeros(n_time,n_field);
                stimulus(n_stim1_on+1:n_stim1_off,:)=ones(n_stim1_off-n_stim1_on,1)*(stim1_input);
                stimulus(n_stim2_on+1:n_stim2_off,:)=ones(n_stim2_off-n_stim2_on,1)*(stim2_input);
                
                transient=zeros(n_time,1);
                transient(n_stim1_on+1:n_stim1_on+transient_time,1)=ones(transient_time,1)*w_trans;
                transient(n_stim2_on+1:n_stim2_on+transient_time,1)=ones(transient_time,1)*w_trans;
                
                % construct h change sequence (controls mode)
                %h_change_g=zeros(n_time,1);  %gate node
                %h_change_g(n_stim2_on+1:n_stim2_off,1)=sum(stimulus(n_stim2_on+1:n_stim2_off,:),2);
                %h_change_i=zeros(n_time,1);
                %h_change_i(n_h_change_i:n_time,1)=h_change_i_amount;
                
                %%%% preparing the kernels
                kernel_width_multiplier=3; %DO NOT SET TO SMALLER THAN 3
                
                uu_kernel_width=floor(min(kernel_width_multiplier*uu_sigma,(n_field-1)/2));
                uu_int_kernel=(w_uu)*(exp(-.5*(-uu_kernel_width:uu_kernel_width).^2/uu_sigma^2));
                uu_ext_index=[n_field-uu_kernel_width+1:n_field, 1:n_field, 1: uu_kernel_width];
                
                uv_kernel_width=floor(min(kernel_width_multiplier*uv_sigma,(n_field-1)/2));
                uv_int_kernel=(w_uv)*(exp(-.5*(-uv_kernel_width:uv_kernel_width).^2/uv_sigma^2));
                uv_ext_index=[n_field-uv_kernel_width+1:n_field, 1:n_field, 1: uv_kernel_width];
                
                vu_kernel_width=floor(min(kernel_width_multiplier*vu_sigma,(n_field-1)/2));
                vu_int_kernel=(w_vu)*(exp(-.5*(-vu_kernel_width:vu_kernel_width).^2/vu_sigma^2));
                vu_ext_index=[n_field-vu_kernel_width+1:n_field, 1:n_field, 1: vu_kernel_width];
                
                vw_kernel_width=floor(min(kernel_width_multiplier*vw_sigma,(n_field-1)/2));
                vw_int_kernel=(w_vw)*(exp(-.5*(-vw_kernel_width:vw_kernel_width).^2/vw_sigma^2));
                vw_ext_index=[n_field-vw_kernel_width+1:n_field, 1:n_field, 1: vw_kernel_width];
                
                wu_kernel_width=floor(min(kernel_width_multiplier*wu_sigma,(n_field-1)/2));
                wu_int_kernel=(w_wu)*(exp(-.5*(-wu_kernel_width:wu_kernel_width).^2/wu_sigma^2));
                wu_ext_index=[n_field-wu_kernel_width+1:n_field, 1:n_field, 1: wu_kernel_width];
                
                wv_kernel_width=floor(min(kernel_width_multiplier*wv_sigma,(n_field-1)/2));
                wv_int_kernel=(w_wv)*(exp(-.5*(-wv_kernel_width:wv_kernel_width).^2/wv_sigma^2));
                wv_ext_index=[n_field-wv_kernel_width+1:n_field, 1:n_field, 1: wv_kernel_width];
                
                ww_kernel_width=floor(min(kernel_width_multiplier*ww_sigma,(n_field-1)/2));
                ww_int_kernel=(w_ww)*(exp(-.5*(-ww_kernel_width:ww_kernel_width).^2/ww_sigma^2));
                ww_ext_index=[n_field-ww_kernel_width+1:n_field, 1:n_field, 1: ww_kernel_width];
                
                % stochastics
                noise_kernel_width=floor(min(kernel_width_multiplier*noise_sigma,(n_field-1)/2));
                noise_kernel=(noise_strength)*(exp(-.5*(-noise_kernel_width:noise_kernel_width).^2/noise_sigma^2));
                noise_size=n_field+2*noise_kernel_width;
                
                %%%%% initiatlization, initial conditions
                u_field =zeros(n_time,n_field) + h_u;
                v_field =zeros(n_time,n_field) + h_v;
                w_field =zeros(n_time,n_field) + h_w;
                gate_node=zeros(n_time,1) + h_g;
                is_node =zeros(n_time,1) + h_is;
                id_node =zeros(n_time,1) + h_id;
                total_U_sig=0;
                total_V_sig=0;
                total_W_sig=0;
                h_noise_u=zeros(n_time);
                h_noise_v=zeros(n_time);
                h_noise_w=zeros(n_time);
                
                CDA_index=1;
                for time=2:n_time
                    
                    if(hemo) timeH = timeH+1; end
                    
                    f_u=sigmoid(u_field(time-1,:),beta,0);
                    f_v=sigmoid(v_field(time-1,:),beta,0);
                    f_w=sigmoid(w_field(time-1,:),beta,0);
                    uu_conv=conv2(1,uu_int_kernel,f_u(uu_ext_index),'valid');
                    uv_conv=conv2(1,uv_int_kernel,f_v(uv_ext_index),'valid');
                    vu_conv=conv2(1,vu_int_kernel,f_u(vu_ext_index),'valid');
                    vw_conv=conv2(1,vw_int_kernel,f_w(vw_ext_index),'valid');
                    wu_conv=conv2(1,wu_int_kernel,f_u(wu_ext_index),'valid');
                    wv_conv=conv2(1,wv_int_kernel,f_v(wv_ext_index),'valid');
                    ww_conv=conv2(1,ww_int_kernel,f_w(ww_ext_index),'valid');
                    if(NOISE)
                        u_noise=conv2(1,noise_kernel,randn(1,noise_size),'valid');
                        v_noise=conv2(1,noise_kernel,randn(1,noise_size),'valid');
                        w_noise=conv2(1,noise_kernel,randn(1,noise_size),'valid');
                        h_noise_u(time) = h_noise_u(time-1) + (-h_noise_u(time-1) + h_noisestr_u*randn)/tau_noise;
                        h_noise_v(time) = h_noise_v(time-1) + (-h_noise_v(time-1) + h_noisestr_v*randn)/tau_noise;
                        h_noise_w(time) = h_noise_w(time-1) + (-h_noise_w(time-1) + h_noisestr_w*randn)/tau_noise;
                    else
                        u_noise=0;
                        v_noise=0;
                        w_noise=0;
                        h_noise_u=0;
                        h_noise_v=0;
                        h_noise_w=0;
                    end %noise
                    
                    %COUPLING DECISION NODES TO FIELDS
                    s_ig=sigmoid(gate_node(time-1,:),beta_i,0);
                    s_id=sigmoid(id_node(time-1,:),beta_i,0);
                    s_is=sigmoid(is_node(time-1,:),beta_i,0);
                    
                    input_from_id=w_uid*s_id;
                    input_from_is=w_wis*s_is;
                    input_u_to_id=w_idu*sum(sigmoid(u_field(time-1,:),beta,0));
                    input_w_to_is=w_isw*sum(sigmoid(w_field(time-1,:),beta,0));
                    input_w_to_ig=w_igw*sum(sigmoid(w_field(time-1,:),beta,0));
                    if(NOISE)  %adding extra noise to nodes to try to reduce perfect performance
                        id_noise=noise_strength_nodes*randn(1,1);
                        is_noise=noise_strength_nodes*randn(1,1);
                        ig_noise=noise_strength_gate*randn(1,1);
                    else
                        id_noise=0;
                        is_noise=0;
                        ig_noise=0;
                    end %noise
                    
                    S = stimulus(time,:);
                    stim_to_ig = w_gS*sum(sigmoid(S,beta,0));
                    
                    % equations
                    gate_node(time,:) = gate_node(time-1,:) + (- gate_node(time-1,:) + h_g + w_gg*s_ig + input_w_to_ig + stim_to_ig + transient(time,1))/tau_g + ig_noise;
                    id_node(time,:) = id_node(time-1,:) + (- id_node(time-1,:) + h_id + w_iiD*s_id + (input_u_to_id + w_ig)*s_ig - ci*s_is)/tau_i + id_noise;
                    is_node(time,:) = is_node(time-1,:) + (- is_node(time-1,:) + h_is + w_iiS*s_is + (input_w_to_is + w_ig)*s_ig - ci*s_id -w_isv*sum(f_v) )/tau_i + is_noise;
                    
                    gateTrack(rct,SStrack,trial_ct,time)=gate_node(time);
                    idTrack(rct,SStrack,trial_ct,time)=id_node(time);
                    isTrack(rct,SStrack,trial_ct,time)=is_node(time);
                    id_u_track(rct,SStrack,trial_ct,time)=input_u_to_id;
                    is_w_track(rct,SStrack,trial_ct,time)=input_w_to_is;
                    is_v_track(rct,SStrack,trial_ct,time)=w_isv*sum(f_v);
                    fuTrack(rct,SStrack,trial_ct,time)=sum(f_u);
                    fwTrack(rct,SStrack,trial_ct,time)=sum(f_w);
                    fvTrack(rct,SStrack,trial_ct,time)=sum(f_v);
                    
                    
                    u_field(time,:) = u_field(time-1,:) + (- u_field(time-1,:) + h_u + h_noise_u(time-1) + input_from_id -w_uis*s_is + S      + uu_conv           - uv_conv - w_uv_const*sum(f_v))/tau_u + u_noise;
                    v_field(time,:) = v_field(time-1,:) + (- v_field(time-1,:) + h_v + h_noise_v(time-1) +                         + vu_conv + vw_conv                                )/tau_v + v_noise;
                    w_field(time,:) = w_field(time-1,:) + (- w_field(time-1,:) + h_w + h_noise_w(time-1) + input_from_is -w_wid*s_id+ S*w_wS + ((1-s_ig)*wu_conv) + ww_conv - wv_conv - w_wv_const*sum(f_v))/tau_w + w_noise;
                    
                    f_wStorage(rct,SStrack,trial_ct,:)=f_w;
                    
                    
                    noiseU(time,:)=u_noise;
                    noiseW(time,:)=w_noise;
                    
                    if storeFields
                        %                     vFieldStorage(rct,SS,trial_ct,:,:)=v_field;
                        %                     wFieldStorage(rct,SS,trial_ct,:,:)=w_field;
                        %                     uFieldStorage(rct,SS,trial_ct,:,:)=u_field;
                    end
                    
                    if (time > (n_stim1_on+150)) && (time < (n_stim1_on+450))   %300-900ms after sample onset
                        sum_U_sig(SStrack,trial_ct,CDA_index)=sum(f_u);
                        %                     total_U_sig(SS,trial_ct,:)=total_U_sig+sum_U_sig;
                        sum_V_sig(SStrack,trial_ct,CDA_index)=sum(f_v);
                        %                     total_V_sig(SS,trial_ct,:)=total_V_sig+sum_V_sig;
                        sum_W_sig(SStrack,trial_ct,CDA_index)=sum(f_w);
                        %                     total_W_sig(SS,trial_ct,:)=total_W_sig+sum_W_sig;
                        CDA_index=CDA_index+1;
                    end
                    
                    if(hemo)
                        
                        factor=.7;%.65;
                        nOut_id(rct,SStrack,timeH) = abs(w_iiD*s_id) + abs( (input_u_to_id+w_ig)*s_ig ) + abs(ci*s_is)*(1-factor) + abs(id_noise);
                        nOut_is(rct,SStrack,timeH) = abs(w_iiS*s_is) + abs( (input_w_to_is+w_ig)*s_ig ) + abs(ci*s_id)*(1-factor) + abs(is_noise) + abs(w_isv*sum(f_v))*(1-factor);
                        nOut_ig(rct,SStrack,timeH) = abs(w_gg*s_ig) + abs(input_w_to_ig) + abs(stim_to_ig) + abs(transient(time,1)) + abs(ig_noise);
                        
                        w_iiDTrack(rct,SStrack,trial_ct,time)=abs(w_iiD*s_id);
                        u_to_id(rct,SStrack,trial_ct,time)=abs( (input_u_to_id+w_ig)*s_ig );
                        s_isTrack(rct,SStrack,trial_ct,time)=abs(ci*s_is*(1-factor));
                        dNoiseTrack(rct,SStrack,trial_ct,time)=abs(id_noise);
                        
                        w_iiSTrack(rct,SStrack,trial_ct,time)=abs(w_iiS*s_is);
                        w_to_is(rct,SStrack,trial_ct,time)=abs( (input_w_to_is+w_ig)*s_ig );
                        s_idTrack(rct,SStrack,trial_ct,time)=abs(ci*s_id*(1-factor));
                        sNoiseTrack(rct,SStrack,trial_ct,time)=abs(is_noise);
                        
                        
                        %                     nOut_u(rct,SStrack,timeH)  = abs(h_noise_u(time-1)) + abs(input_from_id) + abs(w_uis*s_is) + sum( abs(uu_conv) + abs(uv_conv)/n_field + abs(u_noise))/n_field + abs(w_uv_const*sum(f_v));
                        nOut_u(rct,SStrack,timeH)  = abs(h_noise_u(time-1)) + abs(input_from_id) + abs(w_uis*s_is) + sum( abs(uu_conv) + abs(uv_conv)*(1-factor) + abs(u_noise))/(n_field) + abs(w_uv_const*sum(f_v))*(1-factor);
                        
                        
                        nOut_v(rct,SStrack,timeH)  = abs(h_noise_v(time-1)) + sum( abs(vu_conv) + abs(vw_conv) + abs(v_noise) )/n_field;
                        % %                     nOut_w(rct,SStrack,timeH)  = abs(h_noise_w(time-1)) + abs(input_from_is) + sum( (1-s_ig)*abs(wu_conv) + abs(ww_conv) + abs(wv_conv) + abs(w_noise) )/n_field + abs(w_wv_const*sum(f_v));
                        %                     nOut_w(rct,SStrack,timeH)  = abs(h_noise_w(time-1)) + abs(input_from_is) +abs(w_wid*s_id) + sum( (abs(wu_conv)*(1-s_ig)) + abs(ww_conv) + abs(wv_conv)/n_field + abs(w_noise) )/n_field + abs(w_wv_const*sum(f_v));
                        nOut_w(rct,SStrack,timeH)  = abs(h_noise_w(time-1)) + abs(input_from_is) +abs(w_wid*s_id) + sum( (abs(wu_conv)*(1-s_ig)) + abs(ww_conv) + abs(wv_conv)*(1-factor) + abs(w_noise) )/(n_field) + abs(w_wv_const*sum(f_v))*(1-factor);
                        
                        uidTrack(rct,SStrack,timeH)=abs(input_from_id);
                        uisTrack(rct,SStrack,timeH)=abs(w_uis*s_is);
                        uuTrack(rct,SStrack,timeH)=sum(abs(uu_conv))/n_field;
                        uvTrack(rct,SStrack,timeH)=sum(abs(uv_conv)*(1-factor))/(n_field);
                        uvgTrack(rct,SStrack,timeH)=abs(w_uv_const*sum(f_v)*(1-factor));
                        vuTrack(rct,SStrack,timeH)=sum( abs(vu_conv))/n_field;
                        vwTrack(rct,SStrack,timeH)=sum(abs(vw_conv))/n_field;
                        wisTrack(rct,SStrack,timeH)=abs(input_from_is);
                        widTrack(rct,SStrack,timeH)=abs(w_wid*s_id);
                        wuTrack(rct,SStrack,timeH)=sum( (abs(wu_conv)*(1-s_ig)))/n_field;
                        wwTrack(rct,SStrack,timeH)=sum(abs(ww_conv))/n_field;
                        wvTrack(rct,SStrack,timeH)=sum( abs(wv_conv)*(1-factor))/(n_field);
                        wvgTrack(rct,SStrack,timeH)=abs(w_wv_const*sum(f_v)*(1-factor));
                        
                        
                    end
                    
                    %%% for reaction times
                    if TrialOver==0
                        if (id_node(time,:)>0 && is_node(time,:)<0) || (id_node(time,:)<0 && is_node(time,:)>0)
                            RT(rct,SStrack,trial_ct)=time;
                            TrialOver=1;
                        end
                    end
                    
                    if time==n_stim2_on
                        peakCtW=0;
                        actW=find(w_field(time,:)>0);
                        if size(actW,2)>1
                            for actCtW=2:size(actW,2)
                                if actW(actCtW)-actW(actCtW-1)>2
                                    peakCtW=peakCtW+1;
                                end
                            end
                            peakCtW=peakCtW+1;
                        end
                        peakStoreW(rct,SStrack,trial_ct)=peakCtW;
                        
                    end
                    if time==n_time-100;
                        peakCtU=0;
                        sumu=sum(sigmoid(u_field(n_stim2_on:n_stim2_off,:),5,0),2);
                        maxu=max(sumu);
                        indu=n_stim2_on+find(sumu==maxu);
                        
                        actU=find(u_field(indu,:)>0);
                        
                        if size(actU,2)>1
                            peakCtU=peakCtU+1;
                            for actCtU=2:size(actU,2)
                                if actU(actCtU)-actU(actCtU-1)>2
                                    peakCtU=peakCtU+1;
                                end
                            end
                        end
                        peakStoreU(rct,SStrack,trial_ct)=peakCtU;
                    end
                    if time==n_time
                        
                        peakCtWend=0;
                        actWend=find(w_field(time,:)>0);
                        if size(actWend,2)>1
                            for actCtWend=2:size(actWend,2)
                                if actWend(actCtWend)-actWend(actCtWend-1)>2
                                    peakCtWend=peakCtWend+1;
                                end
                            end
                            peakCtWend=peakCtWend+1;
                        end
                        peakStoreWend(rct,SStrack,trial_ct)=peakCtWend;
                    end
                    %summing activation for CDA
                    if time > n_stim1_on+150 && time < n_stim1_on+450   %300-900ms after sample onset
                        sum_U_sig=sum(f_u);
                        total_U_sig=total_U_sig+sum_U_sig;
                        sum_V_sig=sum(f_v);
                        total_V_sig=total_V_sig+sum_V_sig;
                        sum_W_sig=sum(f_w);
                        total_W_sig=total_W_sig+sum_W_sig;
                    end
                    
                    %%% counting the number of peaks at the end of delay
                    if time == n_stim2_on-1
                        peakDistance = 1;
                        supraThreshold = find(f_w >= 0.5)';
                        if size(supraThreshold, 1) < 2
                            nPeaks = 0;
                        else
                            % the actual clustering
                            clusterIndices = clusterdata(supraThreshold, 'distance', 'euclidean', 'linkage',...
                                'single', 'cutoff', peakDistance, 'criterion', 'inconsistent');
                            % determining the centers of the clusters
                            nPeaks = max(clusterIndices);
                            peakCenters = zeros(nPeaks, 1);
                            for i = 1 : nPeaks
                                peakCenters(i, :) = mean(supraThreshold((clusterIndices == i), :));
                            end
                            
                        end
                    end
                    
                end %time loop
                
                
                stimTrack(rct,SStrack,trial_ct,:)=stim1_pos;
                %             figure;
                %             plot(gate_node);
                %             hold;
                %             plot(is_node,'r');
                %             plot(id_node,'k');
                %             hold off;
                
                n_timesteps=n_time;
                time=[1:n_time];
                
                stim1_pos(1,1:SS);
                stim2_pos(1,1:SS);
                steps_diff_above=find(id_node>0);
                steps_same_above=find(is_node>0);
                decision=[size(steps_diff_above) size(steps_same_above)];
                
                if decision(1) == 0 && decision(3) == 0
                    response=-2;
                    class = 0;
                    %CD_node_plot
                elseif decision(1) > 50 && decision(3) > 50
                    %CD_node_plot
                    if decision(1) > decision(3)
                        response=-1;
                    else response=-0.1;
                    end
                    class = 0;
                elseif decision(1) > decision(3)
                    response=1;
                    if change == 1;
                        class = 6; %HIT
                    else class = 7; %MISS
                    end
                else response=0;
                    if change == 0;
                        class = 5; %CR
                    else class = 8; %FA
                    end
                end
                allResponse(SStrack,trial_ct)=response;
                if response==1 && change==1
                    resp(rct,SStrack,trial_ct)=1;
                elseif response==0 && change==0
                    resp(rct,SStrack,trial_ct)=1;
                else
                    resp(rct,SStrack,trial_ct)=0;
                end
                
                %             if STORAGE == 1
                %                 OutName = sprintf('%s.out',SimName);
                %                 OutFile = fopen(OutName,'a');
                %                 if STORE1 == 1
                %                     fprintf(OutFile,'Resp  E  SS  Trial  Peaks  Usig  Vsig  Wsig  CH  Resp  RT  S1  S2  S3  S4  S5  S6  S7  S8  S9  class\n');
                %                     STORE1=0;
                %                 end
                %                 fprintf(OutFile,'%i ',resp(rct,SStrack,:),rct,ct_stim1,trial_ct,nPeaks,total_U_sig,total_V_sig,total_W_sig,change,response,RT,stim1_pos,class);
                %                 fprintf(OutFile,'\n');
                %                 fclose(OutFile);
                %             else
                %                 fprintf('E %i SS %i Peaks %i CH %i Resp %i RT %i \n',rct,ct_stim1,nPeaks,change,response,RT);
                %                 if meshplot ==1
                %                     CD_mesh_plot
                %                 end
                %                 if lineplot == 1
                %                     new_lineplot
                %                 end
                %                 if decision_node_plot == 1
                %                     CD_node_plot
                %                 end
                %
                %             end %storage
                fieldNoiseW(1)=sum(sum(noiseW(275:299,:)));
                fieldNoiseU(1)=sum(sum(noiseU(275:299,:)));
                
                fieldNoiseW(2)=sum(sum(noiseW(775:899,:)));
                fieldNoiseU(2)=sum(sum(noiseU(775:899,:)));
                
                dataOut=[rct,SS,trial_ct,fieldNoiseW,fieldNoiseU,stim1_pos,change,response,resp(rct,SStrack,trial_ct)];
                dlmwrite('Output.txt',dataOut,'-append');
                
                current_iteration=current_iteration+1;
                running_time=running_time+toc(tic_iteration)/60; % in minutes
                est_total_time=(total_iterations*running_time)/(current_iteration);
                fprintf('%i/%i      %0.0fh %0.0fm (completed) / %0.0fh %0.0fm (est. total)\n',current_iteration,total_iterations,...
                    floor(running_time/60),mod(running_time,60),floor(est_total_time/60),mod(est_total_time,60));
            end %trials
        end %SS
        for SS=1:nSS %startSS:stopSS
            for CH=1:2
                TR=find(changeTrack(rct,SS,:)==CH-1);
                ACC(SS,CH)=mean(resp(rct,SS,TR));
            end
        end
        ACC
        ACCall(paramIter,rct,:,:)=ACC;
    end %rct
end %param

for i =1:total_runs
    FA2.run(i).trials=find( (changeTrack(i,1,:) == 0) & (resp(i,1,:)==0) );
    Miss2.run(i).trials=find( (changeTrack(i,1,:) == 1) & (resp(i,1,:)==0) );
    Hit2.run(i).trials=find( (changeTrack(i,1,:) == 1) & (resp(i,1,:)==1) );
    CR2.run(i).trials=find( (changeTrack(i,1,:) == 0) & (resp(i,1,:)==1) );
    
    FA4.run(i).trials=find( (changeTrack(i,2,:) == 0) & (resp(i,2,:)==0) );
    Miss4.run(i).trials=find( (changeTrack(i,2,:) == 1) & (resp(i,2,:)==0) );
    Hit4.run(i).trials=find( (changeTrack(i,2,:) == 1) & (resp(i,2,:)==1) );
    CR4.run(i).trials=find( (changeTrack(i,2,:) == 0) & (resp(i,2,:)==1) );
    
    FA6.run(i).trials=find( (changeTrack(i,3,:) == 0) & (resp(i,3,:)==0) );
    Miss6.run(i).trials=find( (changeTrack(i,3,:) == 1) & (resp(i,3,:)==0) );
    Hit6.run(i).trials=find( (changeTrack(i,3,:) == 1) & (resp(i,3,:)==1) );
    CR6.run(i).trials=find( (changeTrack(i,3,:) == 0) & (resp(i,3,:)==1) );
end
for i=1:total_runs
    su(i)=sum(idTrack(i,3,Miss6.run(i).trials,1300)>0);
end
su'

for i=1:17
    ACCallM(i,:,:)=squeeze(mean(ACCall(i,:,:,:)));
end
save('Acc_WidToInh.mat','ACCall','ACCallM');